<template>
  <q-page>
    <div class="full-width">
      <div class="dapps">
        <div class="category-full-page-header">
          <div class="category-full-page-header-content">
            <div class="back-button">
              <div
                class="back-arrow"
                @click="goBack"
              ></div>
            </div>
            <div class="category-dropdown">
              <div class="header-1-full-dapp-page">
                {{ categoryApps.label }}
              </div>
            </div>
          </div>
        </div>
        <div class="category-full-page">
          <div class="category-full-page-container">
            <div class="dapp-full-page-category-grid">
              <div
                class="full-page-category-dapp"
                v-for="app in categoryApps.apps"
                :key="app.id"
                @click="selectDapp(app)"
              >
                <div
                  class="category-dapp-logo-outlined-full-page"
                  :style="
                    `backgroundImage: url('${app.imgixImageUrl ||
                      app.imageUrl}');`
                  "
                ></div>
                <div class="category-dapp-details-full-page">
                  <div class="category-dapp-title-full-page">
                    {{ app.name }}
                  </div>
                  <div class="category-dapp-description-full-page">
                    {{ app.description }}
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div class="bottom-color-block"></div>
        </div>
      </div>
      <q-dialog
        v-model="dialog"
        height="80%"
        :style="{ width: appCardWidth }"
      >
        <app-card :app="activeDapp" />
      </q-dialog>
    </div>
  </q-page>
</template>

<script>
import AppCard from "../components/AppCard";
import { mapGetters } from "vuex";

export default {
  components: {
    AppCard
  },
  data () {
    return {
      categoryApps: [],
      dialog: false,
      activeDapp: {}
    };
  },
  mounted () {
    let catApps = this.filteredAppsByCategory;
    this.categoryApps = catApps[this.$route.params.id];
  },
  computed: {
    ...mapGetters({
      filteredAppsByCategory: "filteredAppsByCategory",
      categories: "categories"
    }),
    appCardWidth () {
      if (this.$q.screen.xs) {
        return "100%";
      } else {
        return "700px";
      }
    }
  },
  watch: {
    $route () {
      let catApps = this.filteredAppsByCategory;
      this.categoryApps = catApps[this.$route.params.id];
    }
  },
  methods: {
    goBack () {
      this.$router.go(-1);
    },
    selectDapp (data) {
      this.activeDapp = data;
      this.dialog = true;
    }
  }
};
</script>

<style lang="scss" scoped></style>
